<!-- edited with XML Spy v4.3 U (http://www.xmlspy.com) by slobodan (none) -->
<xsl:stylesheet xmlns:doml="http://dods.enhydra.org/schema/eight" xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
	<xsl:output method="html"/>
	<!--<xsl:param name="date"/>          -->
	<!-- 
  Erstellt von der Softmax OEG
  Programmiert von Rene Huber/Alexander Pelzl            /Dragan Radeka 03.02.2003.
  Erstellt:  24.04.2001
  Verändert: 25.04.2001  Design, Links bei den Packages aaa.bbb.ccc.ddd zwischen den Punkten
             26.04.2001  für IE6
             24.09.2001  Links auch auf Klassen gesetzt, nicht nur auf Packages. Backlink.
             03.02.2003. Prepared for *.doml file version 5.* .
                         New table - Index is designed.
-->
	<xsl:template match="doml:doml">

		<xsl:variable name="PKDoml">
			<xsl:if test="doml:defaults/child::*[name(.)='doml:primaryKey']">
				<xsl:for-each select="doml:defaults/doml:primaryKey/doml:column">
					&lt;tr&gt;
						&lt;td&gt;
							<xsl:value-of select="@id"/>
						&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;no&lt;/td&gt;
						&lt;td&gt;
							<xsl:call-template name="findJavaType">
								<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
							</xsl:call-template>
						&lt;/td&gt;
						&lt;td&gt;
							<xsl:call-template name="findDbType">
								<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
								<xsl:with-param name="size">
									<xsl:choose>
										<xsl:when test="@size!=''">
											<xsl:value-of select="@size"/>
										</xsl:when>
										<xsl:when test="@scale!='' and @precision!=''">
											<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:call-template name="findSize">
												<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
											</xsl:call-template>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:with-param>
							</xsl:call-template>
						&lt;/td&gt;
						&lt;td&gt;
							<xsl:choose>
								<xsl:when test="@size!=''">
									<xsl:value-of select="@size"/>
								</xsl:when>
								<xsl:when test="@scale!='' and @precision!=''">
									<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="findSize">
										<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
					&lt;/tr&gt;
				</xsl:for-each>		
			</xsl:if>
		</xsl:variable>			

			<HTML>
				<meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/>
				<title>DOML Documentation <!--<xsl:value-of select="substring-before($date,'_')"/> | <xsl:value-of select="substring-before(substring-after($date,'_'),'_')"/> | <xsl:value-of select="substring-after(substring-after($date,'_'),'_')"/>-->
				</title>
				<style type="text/css">
				td {  font-family: Arial, Helvetica, sans-serif; font-size: 11}
				.white { color: #FFFFFF; font-size: small}
				.white a { color: #FFFFFF}
				.medium { font-size: 14}
				.big { font-size: 18}
				h1 {font-size: 2.00em}
				h2 {font-size: 1.75em}
				h3 {font-size: 1.45em}
				h4 {font-size: 1.30em}
				h5 {font-size: 1.15em}
				h6 {font-size: 1.00em}
				</style>
				<BODY link="#FF0000" vlink="#FF0000" alink="#FF0000" leftmargin="0" topmargin="0" marginwidth="0" marginheight="0">
					<xsl:for-each select="doml:databases/doml:database">

						<xsl:variable name="PKDatabase">
							<xsl:if test="doml:defaults/child::*[name(.)='doml:primaryKey']">
								<xsl:for-each select="doml:defaults/doml:primaryKey/doml:column">
									&lt;tr&gt;
										&lt;td&gt;
											<xsl:value-of select="@id"/>
										&lt;/td&gt;
										&lt;td&gt;.&lt;/td&gt;
										&lt;td&gt;.&lt;/td&gt;
										&lt;td&gt;no&lt;/td&gt;
										&lt;td&gt;
											<xsl:call-template name="findJavaType">
												<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
											</xsl:call-template>
										&lt;/td&gt;
										&lt;td&gt;
											<xsl:call-template name="findDbType">
												<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
												<xsl:with-param name="size">
													<xsl:choose>
														<xsl:when test="@size!=''">
															<xsl:value-of select="@size"/>
														</xsl:when>
														<xsl:when test="@scale!='' and @precision!=''">
															<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
														</xsl:when>
														<xsl:otherwise>
															<xsl:call-template name="findSize">
																<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
															</xsl:call-template>
														</xsl:otherwise>
													</xsl:choose>
												</xsl:with-param>
											</xsl:call-template>
										&lt;/td&gt;
										&lt;td&gt;
											<xsl:choose>
												<xsl:when test="@size!=''">
													<xsl:value-of select="@size"/>
												</xsl:when>
												<xsl:when test="@scale!='' and @precision!=''">
													<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
												</xsl:when>
												<xsl:otherwise>
													<xsl:call-template name="findSize">
														<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
													</xsl:call-template>
												</xsl:otherwise>
											</xsl:choose>
										&lt;/td&gt;
										&lt;td&gt;.&lt;/td&gt;
										&lt;td&gt;.&lt;/td&gt;
									&lt;/tr&gt;
								</xsl:for-each>		
							</xsl:if>
						</xsl:variable>			

						<TABLE BORDER="0" WIDTH="100%" bgcolor="#333333">
							<TR>
								<TD>
									<center>
										<H3>
											<font color="#FFFFFF">Data model-Documentation</font>
										</H3>
										<font color="#FFFFFF">
											<!--<h4>
										<xsl:value-of select="substring-before($date,'_')"/> | <xsl:value-of select="substring-before(substring-after($date,'_'),'_')"/> | 
										<xsl:value-of select="substring-after(substring-after($date,'_'),'_')"/></h4>             -->
										Database: <xsl:value-of select="@id"/>
										</font>
									</center>
								</TD>
							</TR>
						</TABLE>
						<xsl:if test="child::*[name(.)='doml:table']">
							<xsl:call-template name="getclasseswithgenerateSecureInsecure">
								<!--promenjeno ime templejta iz getclasseswithlazycaching - Slobodan Vujasinovic-->
							</xsl:call-template>
						
							<xsl:apply-templates select="doml:table">
								<xsl:sort order="ascending" select="@id"/>
								<xsl:with-param name="PKDatabase" select="$PKDatabase"/>
								<xsl:with-param name="PKDoml" select="$PKDoml"/>
							</xsl:apply-templates>
						</xsl:if>
						
						<xsl:apply-templates select="doml:tableGroup">
							<xsl:sort order="ascending" select="@id"/>
							<xsl:with-param name="PKDatabase" select="$PKDatabase"/>
							<xsl:with-param name="PKDoml" select="$PKDoml"/>
						</xsl:apply-templates>
					</xsl:for-each>
				</BODY>
			</HTML>

	</xsl:template>

	<xsl:template match="doml:tableGroup">
		<!--	<xsl:message>==================================================</xsl:message>   -->
		<xsl:param name="PKDoml"/>
		<xsl:param name="PKDatabase"/>
		<xsl:variable name="ref" select="@ref"/>
		<xsl:variable name="PKTableGroup">
			<!--<xsl:if test="/doml:doml/doml:tableGroups/doml:tgroup[@id=$ref]/defaults/child::*[name(.)='doml:primaryKey']">-->
				<xsl:for-each select="/doml:doml/doml:tableGroups/doml:tgroup[@id=$ref]/doml:defaults/doml:primaryKey/doml:column">
					&lt;tr&gt;
						&lt;td&gt;
							<xsl:value-of select="@id"/>
						&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;no&lt;/td&gt;
						&lt;td&gt;
							<xsl:call-template name="findJavaType">
								<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
							</xsl:call-template>
						&lt;/td&gt;
						&lt;td&gt;
							<xsl:call-template name="findDbType">
								<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
								<xsl:with-param name="size">
									<xsl:choose>
										<xsl:when test="@size!=''">
											<xsl:value-of select="@size"/>
										</xsl:when>
										<xsl:when test="@scale!='' and @precision!=''">
											<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:call-template name="findSize">
												<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
											</xsl:call-template>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:with-param>
							</xsl:call-template>
						&lt;/td&gt;
						&lt;td&gt;
							<xsl:choose>
								<xsl:when test="@size!=''">
									<xsl:value-of select="@size"/>
								</xsl:when>
								<xsl:when test="@scale!='' and @precision!=''">
									<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="findSize">
										<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
					&lt;/tr&gt;
				</xsl:for-each>		
			<!--</xsl:if>-->
		</xsl:variable>			

		<TABLE BORDER="0" WIDTH="100%" bgcolor="#77AA77" cellpadding="0" cellspacing="0">
			<!-- FFFF99 Farbteil 2 -->
			<TR>
				<TD>
					<table border="0" width="100%" cellspacing="5">
						<tr valign="top">
							<td>
								<TABLE>
									<TR valign="top">
										<TD WIDTH="120">
											<!-- Anker für Packages setzen -->
											<xsl:element name="a">
												<xsl:attribute name="name"><xsl:if test="substring-before(@id,'.')='root'"><xsl:value-of select="substring-after(@id,'.')"/></xsl:if><xsl:if test="substring-before(@id,'.')!='root'"><xsl:value-of select="@id"/></xsl:if></xsl:attribute>
											</xsl:element>
											<h3>
												<B>Table Group:</B>
											</h3>
										</TD>
										<TD class="white">
											<b>
												<xsl:value-of select="@ref"/>
											</b>
										</TD>
									</TR>
								</TABLE>
							</td>
							<td class="medium">
								<xsl:if test="count(/doml:doml/doml:tableGroups/doml:tgroup[@id=$ref]/doml:table)>1">
									<h4>
										<b>Classes:</b>
									</h4>
									<br/>
									<xsl:for-each select="/doml:doml/doml:tableGroups/doml:tgroup[@id=$ref]/doml:table">
										<xsl:sort order="ascending" select="@id"/>
										<xsl:variable name="databaseID" select="ancestor::*[name(.)='doml:database']/@id"/>
										<xsl:element name="a">
											<xsl:attribute name="href">#<xsl:value-of select="$databaseID"/>-<xsl:value-of select="@id"/></xsl:attribute>
											<xsl:attribute name="title">to the class: <xsl:value-of select="$databaseID"/>-<xsl:value-of select="@id"/></xsl:attribute>
											<xsl:value-of select="@id"/>
											<br/>
										</xsl:element>
									</xsl:for-each>
								</xsl:if>
							</td>
						</tr>
					</table>
					<xsl:apply-templates select="/doml:doml/doml:tableGroups/doml:tgroup[@id=$ref]/doml:table">
						<xsl:sort order="ascending" select="@id"/>
						<xsl:with-param name="PKTableGroup" select="$PKTableGroup"/>
						<xsl:with-param name="PKDatabase" select="$PKDatabase"/>
						<xsl:with-param name="PKDoml" select="$PKDoml"/>
					</xsl:apply-templates>
				</TD>
			</TR>
		</TABLE>
		<br/>
	</xsl:template>

	<xsl:template match="doml:table">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<!--	<xsl:message>working on class: <xsl:value-of select="@id"/>
		</xsl:message>                                              -->
		<xsl:param name="PKDoml"/>
		<xsl:param name="PKDatabase"/>
		<xsl:param name="PKTableGroup"/>
		<xsl:param name="PKTable">
			<xsl:if test="child::*[name(.)='doml:primaryKey']">
				<xsl:for-each select="doml:primaryKey/doml:column">
					&lt;tr&gt;
						&lt;td&gt;
							<xsl:value-of select="@id"/>
						&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;no&lt;/td&gt;
						&lt;td&gt;
							<xsl:call-template name="findJavaType">
								<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
							</xsl:call-template>
						&lt;/td&gt;
						&lt;td&gt;
							<xsl:call-template name="findDbType">
								<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
								<xsl:with-param name="size">
									<xsl:choose>
										<xsl:when test="@size!=''">
											<xsl:value-of select="@size"/>
										</xsl:when>
										<xsl:when test="@scale!='' and @precision!=''">
											<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:call-template name="findSize">
												<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
											</xsl:call-template>
										</xsl:otherwise>
									</xsl:choose>
								</xsl:with-param>
							</xsl:call-template>
						&lt;/td&gt;
						&lt;td&gt;
							<xsl:choose>
								<xsl:when test="@size!=''">
									<xsl:value-of select="@size"/>
								</xsl:when>
								<xsl:when test="@scale!='' and @precision!=''">
									<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="findSize">
										<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
						&lt;td&gt;.&lt;/td&gt;
					&lt;/tr&gt;
				</xsl:for-each>		
			</xsl:if>
		</xsl:param>	
		
		<xsl:for-each select=".">
			<xsl:sort order="ascending" select="@id"/>
			<div align="center">
				<table bgcolor="#99DD99" width="99%" border="1" bordercolor="#000000">
					<!-- FFFF33 Farbteil 3 -->
					<tr>
						<td>
							<!-- Anker für Klassen setzen -->
							<xsl:element name="a">
								<xsl:attribute name="name"><xsl:value-of select="ancestor::*[name(.)='doml:database']/@id"/>-<xsl:value-of select="@id"/></xsl:attribute>
							</xsl:element>
							<table width="100%" border="0">
							<!-- Optimizovano za novu DOML semu - Dejan Betos -->
								<tr>
									<td width="100">
										<h5>Class:</h5>
									</td>
									<td>
										<h5>
											<xsl:value-of select="@id"/>
										</h5>
									</td>
								</tr>
								<tr>
									<td>
	id:
</td>
									<td>
										<xsl:value-of select="@id"/>
									</td>
								</tr>
								<tr>
									<td>
	Table Name:
</td>
									<td>
										<xsl:value-of select="@name"/>
									</td>
								</tr>
								<tr>
									<!--Dodato umesto isLazy  - Slobodan Vujasinovic-->
									<td>
	GenerateSecure:
</td>
									<td>
												<xsl:choose>
													<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='generateSecure'">
														<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='generateSecure']/@val"/>
													</xsl:when>
													<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='generateSecure'">
														<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='generateSecure']/@val"/>
													</xsl:when>
													<xsl:otherwise>
														<!--default value-->
														false
													</xsl:otherwise>
												</xsl:choose>
									</td>
								</tr>
								<tr>
									<!--Dodato umesto caching  - Slobodan Vujasinovic-->
									<td>
	GenerateInsecure:
</td>
									<td>
										<xsl:choose>
											<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='generateInsecure'">
												<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='generateInsecure']/@val"/>
											</xsl:when>
											<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='generateInsecure'">
												<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='generateInsecure']/@val"/>
											</xsl:when>
											<xsl:otherwise>
												<!--default value-->
												true
											</xsl:otherwise>
										</xsl:choose>
									</td>
								</tr>
								<tr>
									<!--Dodato   - Predrag Djojic-->
									<td>
	MassDeletes:
</td>
									<td>
										<xsl:choose>
											<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='massDeletes'">
												<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='massDeletes']/@val"/>
											</xsl:when>
											<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='massDeletes'">
												<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='massDeletes']/@val"/>
											</xsl:when>
											<xsl:otherwise>
												<!--default value-->
												false
											</xsl:otherwise>
										</xsl:choose>
									</td>
								</tr>
								<tr>
									<!--Dodato  massUpdates - Predrag Djojic-->
									<td>
	MassUpdates:
</td>
									<td>
										<xsl:choose>
											<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='massUpdates'">
												<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='massUpdates']/@val"/>
											</xsl:when>
											<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='massUpdates'">
												<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='massUpdates']/@val"/>
											</xsl:when>
											<xsl:otherwise>
												<!--default value-->
												false
											</xsl:otherwise>
										</xsl:choose>
									</td>
								</tr>
							</table>
							<xsl:variable name="id2find" select="@id"/>
							<xsl:variable name="refanz">
								<xsl:for-each select="//doml:foreignKey">
									<xsl:if test="@foreignTableId=$id2find">.</xsl:if>
								</xsl:for-each>
							</xsl:variable>
							<xsl:if test="string-length($refanz)>0">
								<xsl:call-template name="findreference">
									<xsl:with-param name="table" select="@id"/>
								</xsl:call-template>
							</xsl:if>
							<table width="100%" bgcolor="#CCFFCC" border="1" cellpadding="0" cellspacing="0" rules="rows" bordercolor="#9CDF9C">
								<!-- Farbteil AttrbiuteTable  -->
								<tr bordercolor="#CEFFCE">
									<td colspan="9">
										<div align="center" class="big">Attributes</div>
									</td>
								</tr>
								<tr bordercolor="#CEFFCE">
									<!--bgcolor="#EFEFBC"-->
									<td>
										<b>id</b>
									</td>
									<!--							<td>
									<b>Index</b>
								</td>                        Dragan Radeka  -->
									<td>
										<b>Query</b>
									</td>
									<td>
										<b>Constr</b>
									</td>
									<td>
										<b>Null</b>
									</td>
									<td>
										<b>Java Type</b>
									</td>
									<td>
										<b>DB Type</b>
									</td>
									<td>
										<b>Size</b>
									</td>
									<td>
										<b>Reference</b>
									</td>
									<td>
										<b>Reference Table</b>
									</td>
								</tr>
								<!--Ostavljeno zbog toga sto je sada vrednosty parametra NotUsingOid stalno na false - Slobodan Vujasinovic-->
								<xsl:if test="'true'='true'">
									<xsl:choose>
										<xsl:when test="$PKTable!=''">
											<xsl:value-of disable-output-escaping="yes" select="$PKTable"/>
										</xsl:when>
										<xsl:when test="$PKTableGroup!=''">
											<xsl:value-of disable-output-escaping="yes" select="$PKTableGroup"/>
										</xsl:when>
										<xsl:when test="$PKDatabase!=''">
											<xsl:value-of disable-output-escaping="yes" select="$PKDatabase"/>
										</xsl:when>
										<xsl:otherwise>
											<xsl:value-of disable-output-escaping="yes" select="$PKDoml"/>
										</xsl:otherwise>
									</xsl:choose>
									<!-- call template concurrency -->
									<xsl:choose>
										<xsl:when test="ancestor::*[name(.)='doml:tgroup']/doml:defaults/child::*[name(.)='doml:concurrency']">
											<xsl:call-template name="concurrency">
												<xsl:with-param name="method" select="ancestor::*[name(.)='doml:tgroup']/doml:defaults/doml:concurrency/@method"/>
												<xsl:with-param name="column" select="ancestor::*[name(.)='doml:tgroup']/doml:defaults/doml:concurrency/@column"/>
											</xsl:call-template>
										</xsl:when>
										<xsl:when test="ancestor::*[name(.)='doml:database']/doml:defaults/child::*[name(.)='doml:concurrency']">
											<xsl:call-template name="concurrency">
												<xsl:with-param name="method" select="ancestor::*[name(.)='doml:database']/doml:defaults/doml:concurrency/@method"/>
												<xsl:with-param name="column" select="ancestor::*[name(.)='doml:database']/doml:defaults/doml:concurrency/@column"/>
											</xsl:call-template>											
										</xsl:when>
										<xsl:otherwise>
											<xsl:call-template name="concurrency">									
												<xsl:with-param name="method" select="/doml:doml/doml:defaults/doml:concurrency/@method"/>
												<xsl:with-param name="column" select="/doml:doml/doml:defaults/doml:concurrency/@column"/>
											</xsl:call-template>											
										</xsl:otherwise>
									</xsl:choose>										
								</xsl:if>
								<xsl:apply-templates select="doml:columns/*"/>
							</table>
							<br/>
							<xsl:variable name="statisticsno" select="count(doml:indexes/doml:index[child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='isStatistics']]/doml:include)"/>
							<xsl:variable name="indexno" select="count(doml:indexes/doml:index/doml:include)-$statisticsno"/>
						<!--<xsl:message>
							indexno=<xsl:value-of select="number($indexno)"/> statisticsno=<xsl:value-of select="number($statisticsno)"/>
						</xsl:message>   -->                               
							<xsl:if test="$indexno>0">
								<table width="100%" bgcolor="#CCFFCC" border="1" cellpadding="0" cellspacing="0" rules="rows" bordercolor="#9CDF9C">
									<!-- IndexTable     Dragan Radeka -->
									<tr bordercolor="#CEFFCE">
										<td colspan="4">
											<div align="center" class="big">Indexes</div>
										</td>
									</tr>
									<tr bordercolor="#CEFFCE">
										<td colspan="3">
											<div align="left" class="medium">index</div>
										</td>
										<td colspan="1">
											<div align="left" class="medium">indexColumn</div>
										</td>
									</tr>
									<tr bordercolor="#CEFFCE">
										<!--bgcolor="#EFEFBC"-->
										<td>
											<b>id</b>
										</td>
										<td>
											<b>unique</b>
										</td>
										<td>
											<b>clustered</b>
										</td>
										<td>
											<b>id</b>
										</td>
										<td>
											<b>included</b>
										</td>
									</tr>
									<xsl:apply-templates select="doml:indexes/doml:index"/>
								</table>
							</xsl:if>
							<br/>
							<!--<xsl:variable name="statisticsno" select="count(statistics/statisticsColumn)"/>-->
							<xsl:if test="$statisticsno>0">
								<table width="100%" bgcolor="#CCFFCC" border="1" cellpadding="0" cellspacing="0" rules="rows" bordercolor="#9CDF9C">
									<tr bordercolor="#CEFFCE">
										<td colspan="6">
											<div align="center" class="big">Statistics</div>
										</td>
									</tr>
									<tr bordercolor="#CEFFCE">
										<td colspan="5">
											<div align="left" class="medium">statistic</div>
										</td>
										<td colspan="1">
											<div align="left" class="medium">statisticColumn</div>
										</td>
									</tr>
									<tr bordercolor="#CEFFCE">
										<!--bgcolor="#EFEFBC"-->
										<td>
											<b>id</b>
										</td>
										<td>
											<b>fullScan</b>
										</td>
										<td>
											<b>sampleType</b>
										</td>
										<td>
											<b>sampleNo</b>
										</td>
										<td>
											<b>noRecompute</b>
										</td>
									</tr>
									<xsl:apply-templates select="doml:indexes/doml:index" mode="statistics"/>
								</table>
							</xsl:if>
							<br/>
							<xsl:variable name="docanz" select="count(doml:columns/doml:column[child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='javadoc']])"/>
							<xsl:variable name="docanzfk" select="count(doml:columns/doml:foreignKey/doml:fkcolumn[child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='javadoc']])"/>
<!--						<xsl:message>
							docanz= <xsl:value-of select="number($docanz)"/>
						</xsl:message>-->
							<xsl:if test="$docanz>0 or $docanzfk>0">
								<xsl:call-template name="javadoc"/>
							</xsl:if>
						</td>
					</tr>
				</table>
			</div>
			<p/>
		</xsl:for-each>
	</xsl:template>

	<xsl:template name="concurrency">
		<xsl:param name="method"/>
		<xsl:param name="column"/>
		<tr>
			<td>
				<xsl:value-of select="$column"/>
			</td>
			<td>.</td>
			<td>.</td>
			<td>no</td>
			<td>
				<xsl:choose>
					<xsl:when test="$method='increment'">
						<xsl:value-of select="'int'"/>
					</xsl:when>
					<xsl:when test="$method='timestamp'">
						<xsl:value-of select="'Timestamp'"/>
					</xsl:when>
					<xsl:otherwise>
					<!-- TODO -->
						.
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:choose>
					<xsl:when test="$method='increment'">
						<xsl:value-of select="'INTEGER'"/>
					</xsl:when>
					<xsl:when test="$method='timestamp'">
						<xsl:value-of select="'TIMESTAMP'"/>
					</xsl:when>
					<xsl:otherwise>
					<!-- TODO -->
						.
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>
				<xsl:choose>
					<xsl:when test="$method='increment'">
						<xsl:value-of select="'4,0'"/>
					</xsl:when>
					<xsl:otherwise>
					<!-- TODO -->
						.
					</xsl:otherwise>
				</xsl:choose>
			</td>
			<td>.</td>
			<td>.</td>
		</tr>
	</xsl:template>
	
	<xsl:template match="doml:columnGroup">
		<!--	<xsl:message>==================================================</xsl:message>   -->
		<xsl:variable name="ref" select="@ref"/>
		<xsl:apply-templates select="/doml:doml/doml:columnGroups/doml:group[@id=$ref]/doml:column">
			<xsl:sort order="ascending" select="@id"/>
		</xsl:apply-templates>
		<br/>
	</xsl:template>

	<xsl:template match="doml:foreignKey">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<xsl:variable name="foreignTableId" select="@foreignTableId"/>
		<tr>
			<xsl:for-each select=".">
				<td>
					<xsl:value-of select="doml:fkcolumn/@name"/>
				</td>
				<!--			<td>                                      Dragan Radeka  -->
				<!--				<xsl:if test="@isIndex='true'">yes</xsl:if>
					<xsl:if test="@isIndex!='true'">no</xsl:if>
					<xsl:if test="not(@isIndex)">no</xsl:if>     Dragan Radeka  -->
				<!--				<xsl:call-template name="index1">
    				  <xsl:with-param name="index1" select="@id"/>
    				</xsl:call-template>
				</td>                                     Dragan Radeka  -->
				<td>
					<xsl:if test="doml:column/@usedForQuery='true'">yes</xsl:if>
					<xsl:if test="doml:column/@usedForQuery!='true'">no</xsl:if>
					<xsl:if test="not(doml:column/@usedForQuery)">no</xsl:if>
				</td>
				<td>
					<xsl:for-each select="doml:extendedAttributes/doml:extendedAttribute">
						<xsl:if test="@id='constraint'">
							<xsl:if test="@val='true'">yes</xsl:if>
							<xsl:if test="@val!='true'">no</xsl:if>
						</xsl:if>
					</xsl:for-each>
					<xsl:if test="not(child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='constraint'])">no</xsl:if>
				</td>
				<td>
					<xsl:if test="@canBeNull='true'">yes</xsl:if>
					<xsl:if test="@canBeNull!='true'">no</xsl:if>
					<xsl:if test="not(@canBeNull)">no</xsl:if>
				</td>
				<td>
					<xsl:for-each select="//doml:table[@id=$foreignTableId]">
						<xsl:for-each select="doml:extendedAttributes/doml:extendedAttribute[@id='javaName']">
							<xsl:if test="contains(@val,'.')">
								<!-- kann a.b.c.d oder auch nur 'wert' sein -->
								<xsl:call-template name="functionpack">
									<xsl:with-param name="ID" select="@val"/>
								</xsl:call-template>
							</xsl:if>
							<xsl:if test="not(contains(@val,'.'))">
								<!-- else -->
								<xsl:value-of select="@val"/>
							</xsl:if>DO
						</xsl:for-each>
					</xsl:for-each>
				</td>
				<td>
					<xsl:if test="not(@logicalTypeId) or @logicalTypeId='none'">DECIMAL
			</xsl:if>
					<xsl:if test="@logicalTypeId!='none'">
						<xsl:value-of select="@logicalTypeId"/>
					</xsl:if>
				</td>
				<td>
					<xsl:if test="not(@logicalTypeId) or @logicalTypeId='none'">19,0
			</xsl:if>
					<xsl:if test="@logicalTypeId!='none'">
						<xsl:value-of select="@size"/>
					</xsl:if>
				</td>
				<td>
					<xsl:element name="a">
						<xsl:attribute name="href">#<xsl:value-of select="ancestor::*[name(.)='doml:database']/@id"/>-<xsl:value-of select="@foreignTableId"/></xsl:attribute>
						<xsl:attribute name="title"><xsl:value-of select="ancestor::*[name(.)='doml:database']/@id"/>-<xsl:value-of select="@foreignTableId"/></xsl:attribute>
						<xsl:value-of select="@foreignTableId"/>
					</xsl:element>
				</td>
				<td>
					<xsl:if test="@foreignTableId">
						<xsl:call-template name="findtable">
							<xsl:with-param name="table" select="@foreignTableId"/>
						</xsl:call-template>
					</xsl:if>
				</td>
			</xsl:for-each>
		</tr>
	</xsl:template>

	<xsl:template match="doml:column">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<xsl:variable name="logicalTypeId" select="@logicalTypeId"/>
		<tr>
			<xsl:for-each select=".">
				<td>
					<xsl:value-of select="@id"/>
				</td>
				<!--			<td>                                      Dragan Radeka  -->
				<!--				<xsl:if test="@isIndex='true'">yes</xsl:if>
					<xsl:if test="@isIndex!='true'">no</xsl:if>
					<xsl:if test="not(@isIndex)">no</xsl:if>     Dragan Radeka  -->
				<!--				<xsl:call-template name="index1">
    				  <xsl:with-param name="index1" select="@id"/>
    				</xsl:call-template>
				</td>                                     Dragan Radeka  -->
				<td>
					<xsl:if test="@usedForQuery='true'">yes</xsl:if>
					<xsl:if test="@usedForQuery!='true'">no</xsl:if>
					<xsl:if test="not(@usedForQuery)">no</xsl:if>
				</td>
				<td>
<!--					<xsl:for-each select="doml:extendedAttributes">
						<xsl:if test="doml:extendedAttribute/@id='constraint'">
							<xsl:if test="doml:extendedAttribute/@value='true'">yes</xsl:if>
							<xsl:if test="doml:extendedAttribute/@value!='true'">no</xsl:if>
						</xsl:if>
					</xsl:for-each>
					<xsl:if test="not(child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='constraint'])">false</xsl:if>-->
					
					<xsl:choose>
						<xsl:when test="child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='constraint']">
							<xsl:for-each select="doml:extendedAttributes/doml:extendedAttribute">
								<xsl:if test="@id='constraint'">
									<xsl:if test="@val='true'">yes</xsl:if>
									<xsl:if test="@val!='true'">no</xsl:if>
								</xsl:if>
							</xsl:for-each>
							<xsl:if test="not(child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='constraint'])">no</xsl:if>
						</xsl:when>
						<xsl:otherwise>
							<xsl:if test="not(child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='constraint'])">no</xsl:if>
						</xsl:otherwise>
					</xsl:choose>
				</td>
				<td>
					<xsl:if test="@canBeNull='true'">yes</xsl:if>
					<xsl:if test="@canBeNull!='true'">no</xsl:if>
					<xsl:if test="not(@canBeNull)">no</xsl:if>
				</td>
				<td>
					<xsl:call-template name="findJavaType">
						<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
					</xsl:call-template>
				</td>
				<td>
					<!--<xsl:if test="@logicalTypeId='none'">DECIMAL
					</xsl:if>-->
					<xsl:call-template name="findDbType">
						<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
						<xsl:with-param name="size">
							<xsl:choose>
								<xsl:when test="@size!=''">
									<xsl:value-of select="@size"/>
								</xsl:when>
								<xsl:when test="@scale!='' and @precision!=''">
									<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
								</xsl:when>
								<xsl:otherwise>
									<xsl:call-template name="findSize">
										<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
									</xsl:call-template>
								</xsl:otherwise>
							</xsl:choose>
						</xsl:with-param>
					</xsl:call-template>
					<!--<xsl:if test="@logicalTypeId!='none'">
						<xsl:value-of select="@logicalTypeId"/>
					</xsl:if>-->
				</td>
				<td>
					<!--<xsl:if test="@logicalTypeId='none'">19,0
					</xsl:if>-->
					<xsl:if test="@logicalTypeId!='none'">
						<xsl:choose>
							<xsl:when test="@size!=''">
								<xsl:value-of select="@size"/>
							</xsl:when>
							<xsl:when test="@scale!='' and @precision!=''">
								<xsl:value-of select="@precision"/>,<xsl:value-of select="@scale"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:call-template name="findSize">
									<xsl:with-param name="logicalDomainID" select="@logicalTypeId"/>
								</xsl:call-template>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:if>
				</td>
				<td>
.
				</td>
				<td>
.
				</td>
			</xsl:for-each>
		</tr>
	</xsl:template>
	<!--
Function:     findValue
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dejan Betos 06.08.2007. -->
	<xsl:template name="findValue">
		<xsl:param name="logicalDomainID"/>
		<xsl:variable name="default" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/doml:value[@name='isConstant']/@default"/>
		<xsl:choose>
			<xsl:when test="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/doml:value[@name='isConstant']">
				<xsl:if test="$default='true'">yes</xsl:if>
				<xsl:if test="$default!='true'">no</xsl:if>
			</xsl:when>
			<xsl:when test="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID][@baseDataTypeId!='']">
				<xsl:call-template name="findValue">
					<xsl:with-param name="logicalDomainID" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@baseDataTypeId"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<!-- step out from recursion -->
				<xsl:if test="not(child::*[name(.)='doml:value'][@name='isConstant'])">false</xsl:if>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
Function:     findSize
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dejan Betos 06.08.2007. -->
	<xsl:template name="findSize">
		<xsl:param name="logicalDomainID"/>
		<xsl:variable name="size" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@size"/>
		<xsl:variable name="scale" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@scale"/>
		<xsl:variable name="precision" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@precision"/>
		<xsl:variable name="baseDataTypeId" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@baseDataTypeId"/>
		<!--<xsl:for-each select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]">-->
			<xsl:choose>
				<xsl:when test="$size!=''">
					<xsl:value-of select="$size"/>
				</xsl:when>
				<xsl:when test="$scale!='' and $precision!=''">
					<xsl:value-of select="$precision"/>,<xsl:value-of select="$scale"/>
				</xsl:when>
				<xsl:when test="$baseDataTypeId!=''">
					<xsl:call-template name="findSize">
						<xsl:with-param name="logicalDomainID" select="$baseDataTypeId"/>
					</xsl:call-template>
				</xsl:when>
				<xsl:otherwise>
					<!-- step out from recursion -->
					.
				</xsl:otherwise>
			</xsl:choose>
		<!--</xsl:for-each>-->
	</xsl:template>
	<!--
Function:     findJavaType
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dejan Betos 29.08.2007. -->
	<xsl:template name="findJavaType">
		<xsl:param name="logicalDomainID"/>
		<xsl:variable name="value" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/doml:extendedAttributes/doml:extendedAttribute[@id='javaType']/@val"/>
		<xsl:variable name="baseDataTypeId" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@baseDataTypeId"/>
		<xsl:choose>
			<xsl:when test="$value!=''">
				<xsl:value-of select="$value"/>
			</xsl:when>
			<xsl:when test="$baseDataTypeId!=''">
				<xsl:call-template name="findJavaType">
					<xsl:with-param name="logicalDomainID" select="$baseDataTypeId"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<!-- step out from recursion - there are four basic types -->
				<xsl:choose>
					<xsl:when test="$logicalDomainID='TEXTUAL'">
						<xsl:value-of select="'String'"/>
					</xsl:when>
					<xsl:when test="$logicalDomainID='NUMERIC'">
						<xsl:value-of select="'java.math.BigDecimal'"/>
					</xsl:when>
					<xsl:when test="$logicalDomainID='DATETIME'">
						<xsl:value-of select="'Timestamp'"/>
					</xsl:when>
					<xsl:when test="$logicalDomainID='BINARY'">
						<xsl:value-of select="'byte[]'"/>
					</xsl:when>
					<xsl:otherwise>
						<!--no base Data Type-->
						.
					</xsl:otherwise>
				</xsl:choose>
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
Function:     findDbType
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dejan Betos 29.08.2007. -->
	<xsl:template name="findDbType">
		<xsl:param name="logicalDomainID"/>
		<xsl:param name="size"/>
		<xsl:variable name="value" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/doml:extendedAttributes/doml:extendedAttribute[@id='dbType']/@val"/>
		<xsl:variable name="baseDataTypeId" select="/doml:doml/doml:dimensions/doml:dimension/doml:logicalDomain[@id=$logicalDomainID]/@baseDataTypeId"/>
		<xsl:choose>
			<xsl:when test="$value!=''">
				<xsl:value-of select="$value"/>
			</xsl:when>
			<xsl:when test="$baseDataTypeId!=''">
				<xsl:call-template name="findDbType">
					<xsl:with-param name="logicalDomainID" select="$baseDataTypeId"/>
					<xsl:with-param name="size" select="$size"/>
				</xsl:call-template>
			</xsl:when>
			<xsl:otherwise>
				<!-- step out from recursion - there is no javaType so we pick the most appropriate -->
				<xsl:choose>
					<xsl:when test="$logicalDomainID='TEXTUAL'">
						<xsl:choose>
							<xsl:when test="number($size) &gt; 4000">
								<xsl:value-of select="'LONGVARCHAR'"/>
							</xsl:when>
							<xsl:otherwise>
								<xsl:value-of select="'VARCHAR'"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="$logicalDomainID='NUMERIC'">
						
						<xsl:choose>
							<!--<xsl:when test="$size!='' and substring-after($size,',')='0' and contains('1;2;3;', concat(substring-before($size,','),';'))">-->
							<xsl:when test="$size!='' and substring-after($size,',')='0' and number(substring-before($size,',')) &gt; 0 and number(substring-before($size,',')) &lt; 4">
								<xsl:value-of select="'BIT'"/>
							</xsl:when>
							<xsl:when test="$size!='' and substring-after($size,',')='0' and number(substring-before($size,',')) &gt; 3 and number(substring-before($size,',')) &lt; 9">
								<xsl:value-of select="'SMALLINT'"/>
							</xsl:when>
							<xsl:when test="$size!='' and substring-after($size,',')='0' and number(substring-before($size,',')) &gt; 8 and number(substring-before($size,',')) &lt; 13">
								<xsl:value-of select="'INTEGER'"/>
							</xsl:when>
							<xsl:when test="$size!='' and substring-after($size,',')='0' and number(substring-before($size,',')) &gt; 12">
								<xsl:value-of select="'BIGINT'"/>
							</xsl:when>

							<xsl:when test="$size!='' and substring-after($size,',')!='' and number(substring-before($size,',')) &gt; 0 and number(substring-before($size,',')) &lt; 17 and number(substring-before($size,',')) &gt; 0 and number(substring-after($size,',')) &lt; 9">
								<xsl:value-of select="'FLOAT'"/>
							</xsl:when>
							<xsl:when test="$size!='' and substring-after($size,',')!='' and number(substring-before($size,',')) &gt; 0 and number(substring-before($size,',')) &lt; 17 and number(substring-before($size,',')) &gt; 0 and number(substring-after($size,',')) &lt; 17">
								<xsl:value-of select="'DOUBLE'"/>
							</xsl:when>
							
							<xsl:otherwise>
								<xsl:value-of select="'DECIMAL'"/>
							</xsl:otherwise>
						</xsl:choose>
					</xsl:when>
					<xsl:when test="$logicalDomainID='DATETIME'">
						<xsl:value-of select="'TIMESTAMP'"/>
					</xsl:when>
					<!--<xsl:when test="$logicalDomainID='BINARY'">
						<xsl:value-of select="'byte[]'"/>
					</xsl:when>-->
					<xsl:otherwise>
						<xsl:value-of select="$logicalDomainID"/>
					</xsl:otherwise>
				</xsl:choose>
				<!--<xsl:value-of select="$logicalDomainID"/>-->
			</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
Function:     index1
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dragan Radeka 19.01.2003.-->
	<xsl:template name="index1">
		<xsl:param name="index1"/>
		<xsl:param name="index2" select="$index1"/>
		<xsl:choose>
			<xsl:when test="../index/indexColumn[@id=$index2]">
				<xsl:for-each select="../index/indexColumn[@id=$index2]">
					<xsl:choose>
						<xsl:when test="../@unique='true'">Unique</xsl:when>
						<xsl:otherwise>notUnique</xsl:otherwise>
					</xsl:choose>
				</xsl:for-each>
			</xsl:when>
			<xsl:otherwise>no</xsl:otherwise>
		</xsl:choose>
	</xsl:template>
	<!--
Function:     index
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dragan Radeka 29.01.2003.-->
	<xsl:template match="doml:index">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<xsl:if test="not(child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='isStatistics'])">
			<xsl:for-each select=".">
				<xsl:for-each select="doml:include">
					<tr>
						<td>
							<xsl:value-of select="../@id"/>
						</td>
						<td>
							<xsl:if test="../@unique='true'">yes</xsl:if>
							<xsl:if test="../@unique!='true'">no</xsl:if>
							<xsl:if test="not(../@unique)">no</xsl:if>
						</td>
						<td>
							<xsl:if test="../@clustered='true'">yes</xsl:if>
							<xsl:if test="../@clustered!='true'">no</xsl:if>
							<xsl:if test="not(../@clustered)">no</xsl:if>
						</td>
						<td>
							<xsl:value-of select="@column"/>
						</td>
						<td>
						</td>
					</tr>
				</xsl:for-each>
				<xsl:for-each select="doml:extendedAttributes/doml:extendedAttribute[@id='includeIndexColumn']/doml:val/*">
					<tr>
						<td>
							<xsl:value-of select="../../../../@id"/>
						</td>
						<td>
						</td>
						<td>
						</td>
						<td>
						</td>
						<td>
							<xsl:value-of select="@id"/>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>
	<!--

Function:     statistics
Parameter:    char ID    e.g. "aaa"
Beschreibung: 
This template was added by Dejan Betos 7.08.2007.-->
	<xsl:template match="doml:index" mode="statistics">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<xsl:if test="child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='isStatistics']">
			<xsl:for-each select=".">
				<xsl:for-each select="doml:include">
					<tr>
						<td>
							<xsl:value-of select="../@id"/>
						</td>
						<td>
							<xsl:for-each select="../doml:extendedAttributes/doml:extendedAttribute">
								<xsl:if test="@id='fullScan'">
									<xsl:if test="@val='true'">yes</xsl:if>
									<xsl:if test="@val!='true'">no</xsl:if>
								</xsl:if>
							</xsl:for-each>
							<xsl:if test="not(../child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='fullScan'])">no</xsl:if>
						</td>
						<td>
							<xsl:for-each select="../doml:extendedAttributes/doml:extendedAttribute">
								<xsl:if test="@id='sampleType'">
									<xsl:if test="@val='row'">ROW</xsl:if>
									<xsl:if test="@val='percent'">PERCENT</xsl:if>
									<xsl:if test="@val='none'">none</xsl:if>
								</xsl:if>
							</xsl:for-each>
							<xsl:if test="not(../child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='sampleType'])">none</xsl:if>
						</td>
						<td>
							<xsl:for-each select="../doml:extendedAttributes/doml:extendedAttribute">
								<xsl:if test="@id='sampleNo'">
									<xsl:value-of select="@val"/>
								</xsl:if>
							</xsl:for-each>
						</td>
						<td>
							<xsl:for-each select="../doml:extendedAttributes/doml:extendedAttribute">
								<xsl:if test="@id='noRecompute'">
									<xsl:if test="@val='true'">yes</xsl:if>
									<xsl:if test="@val!='true'">no</xsl:if>
								</xsl:if>
							</xsl:for-each>
							<xsl:if test="not(../child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='noRecompute'])">no</xsl:if>
						</td>
						<td>
							<xsl:value-of select="@column"/>
						</td>
					</tr>
				</xsl:for-each>
			</xsl:for-each>
		</xsl:if>
	</xsl:template>

	<!--
Function:     functionpack
Parameter:    char ID    e.g. "aaa.bbb.ccc"
Beschreibung: Holt die Zeichenkette nach dem letzten Punkt
-->
	<xsl:template name="functionpack">
		<xsl:param name="ID"/>
		<xsl:variable name="varpack">
			<xsl:value-of select="substring-after($ID,'.')"/>
		</xsl:variable>
		<xsl:if test="string-length(substring-after($varpack,'.'))>0">
			<xsl:call-template name="functionpack">
				<xsl:with-param name="ID" select="$varpack"/>
			</xsl:call-template>
		</xsl:if>
		<xsl:if test="string-length(substring-after($varpack,'.'))=0">
			<xsl:value-of select="$varpack"/>
		</xsl:if>
	</xsl:template>
	<!--
Function:     functionpack2
Parameter:    char ID    e.g. "aaa.bbb.ccc"
Beschreibung: Holt alle Zeichenketten, _exclusive_ der letzten!!
-->
	<xsl:template name="functionpack2">
		<xsl:param name="ID"/>
		<!-- <xsl:value-of select="$ID"/> -->
		<xsl:variable name="varpack">
			<xsl:if test="substring-before($ID,'.')='root'">
				<xsl:call-template name="functionpack">
					<xsl:with-param name="ID" select="substring-after($ID,'.')"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:if test="substring-before($ID,'.')!='root'">
				<xsl:call-template name="functionpack">
					<xsl:with-param name="ID" select="$ID"/>
				</xsl:call-template>
			</xsl:if>
		</xsl:variable>
		<xsl:value-of select="substring(substring-after($ID,'.'),1,string-length(substring-after($ID,'.'))-string-length($varpack)-1)"/>
	</xsl:template>
	<!--
Function:     linktree
Parameter:    char Reststring    e.g. "aaa.bbb.ccc"
              char Wurzel, Aktuell (Intern)
Beschreibung: Hinterlegt den Text zwischen den Punkten mit Links.
-->
	<xsl:template name="linktree">
		<xsl:param name="reststring"/>
		<xsl:variable name="databaseID" select="ancestor::*[name(.)='doml:database']/@id"/>
		<!--	<xsl:param name="wurzel"/>
		<xsl:param name="aktuell"/>           -->
		<xsl:if test="string-length(substring-after($reststring,'.'))=0">
			<font color="#FFFFFF">
				<xsl:value-of select="$reststring"/>
			</font>
		</xsl:if>
		<xsl:if test="string-length(substring-after($reststring,'.'))>0">
			<xsl:variable name="wurzel_a">
				<!--			<xsl:if test="string-length($wurzel)>0">           -->
				<!--				<xsl:value-of select="concat($wurzel,'.',substring-before($reststring,'.'))"/>    -->
				<!--			</xsl:if>                                          -->
				<!--			<xsl:if test="string-length($wurzel)=0">           -->
				<xsl:value-of select="substring-before($reststring,'.')"/>
				<!--			</xsl:if>                                          -->
			</xsl:variable>
			<xsl:variable name="aktuell">
				<xsl:value-of select="substring-before($reststring,'.')"/>
			</xsl:variable>
			<xsl:variable name="reststring">
				<xsl:value-of select="substring-after($reststring,'.')"/>
			</xsl:variable>
			<xsl:element name="a">
				<!--			<xsl:if test="string-length($wurzel)>0">           -->
				<xsl:attribute name="href">#<xsl:value-of select="$databaseID"/>-<xsl:value-of select="$wurzel_a"/></xsl:attribute>
				<xsl:attribute name="title"><xsl:value-of select="$databaseID"/>-<xsl:value-of select="$wurzel_a"/></xsl:attribute>
				<xsl:value-of select="$aktuell"/>
				<!--			</xsl:if>                                          -->
			</xsl:element>
			<!--	<xsl:message>==================================================</xsl:message>
		<xsl:message>wurzel = <xsl:value-of select="$wurzel_a"/>
		</xsl:message>
		<xsl:message>aktuell = <xsl:value-of select="$aktuell"/>
		</xsl:message>
		<xsl:message>reststring = <xsl:value-of select="$reststring"/>
		</xsl:message>
		<xsl:message>==================================================</xsl:message>   -->
			<xsl:if test="string-length(substring-after($reststring,'.'))>0">.<!-- Ruf dich selbst auf mit Parametern -->
				<xsl:call-template name="linktree2">
					<xsl:with-param name="wurzel" select="$wurzel_a"/>
					<xsl:with-param name="aktuell" select="$aktuell"/>
					<xsl:with-param name="reststring" select="$reststring"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:if test="string-length(substring-after($reststring,'.'))=0">.<!-- this is the last element in the linkchain -->
				<!-- wenn das Element mit der id "$reststring ist ein table, dann class -->
				<!-- wenn id des Knotens mit der id "$reststring ist ein table, dann class 
				<xsl:if test="//*::@id=$reststring">
				<xsl:message><xsl:value-of select="name(//*[@id=concat($wurzel,'.',$reststring)])"/></xsl:message>
				<xsl:if test="name(//*[@id=concat($wurzel,'.',$reststring)])='table'">-->
				<xsl:element name="a">
					<xsl:attribute name="href">#<xsl:value-of select="$databaseID"/>-<xsl:value-of select="concat($wurzel_a,'.',$reststring)"/></xsl:attribute>
					<xsl:attribute name="title"><xsl:value-of select="$databaseID"/>-<xsl:value-of select="concat($wurzel_a,'.',$reststring)"/></xsl:attribute>
					<xsl:value-of select="$reststring"/>
				</xsl:element>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<!--
Function:     linktree2
Parameter:    char Reststring    e.g. "aaa.bbb.ccc"
              char Wurzel, Aktuell (Intern)
Beschreibung: Hinterlegt den Text zwischen den Punkten mit Links.
This template was added by Dragan Radeka 19.01.2003.
-->
	<xsl:template name="linktree2">
		<xsl:param name="reststring"/>
		<xsl:param name="wurzel"/>
		<xsl:param name="aktuell"/>
		<xsl:if test="string-length(substring-after($reststring,'.'))=0">
			<font color="#FFFFFF">
				<xsl:value-of select="$reststring"/>
			</font>
		</xsl:if>
		<xsl:if test="string-length(substring-after($reststring,'.'))>0">
			<xsl:variable name="wurzel_a">
				<!--			<xsl:if test="string-length($wurzel)>0">       -->
				<xsl:value-of select="concat($wurzel,'.',substring-before($reststring,'.'))"/>
				<!--			</xsl:if>
				<xsl:if test="string-length($wurzel)=0">
					<xsl:value-of select="substring-before($reststring,'.')"/>
				</xsl:if>                                     -->
			</xsl:variable>
			<xsl:variable name="aktuell">
				<xsl:value-of select="substring-before($reststring,'.')"/>
			</xsl:variable>
			<xsl:variable name="reststring">
				<xsl:value-of select="substring-after($reststring,'.')"/>
			</xsl:variable>
			<xsl:variable name="databaseID" select="ancestor::*[name(.)='doml:database']/@id"/>
			<xsl:element name="a">
				<xsl:if test="string-length($wurzel)>0">
					<xsl:attribute name="href">#<xsl:value-of select="$databaseID"/>-<xsl:value-of select="$wurzel_a"/></xsl:attribute>
					<xsl:attribute name="title"><xsl:value-of select="$databaseID"/>-<xsl:value-of select="$wurzel_a"/></xsl:attribute>
					<xsl:value-of select="$aktuell"/>
				</xsl:if>
			</xsl:element>
			<!--	<xsl:message>==================================================</xsl:message>
		<xsl:message>wurzel = <xsl:value-of select="$wurzel_a"/>
		</xsl:message>
		<xsl:message>aktuell = <xsl:value-of select="$aktuell"/>
		</xsl:message>
		<xsl:message>reststring = <xsl:value-of select="$reststring"/>
		</xsl:message>
		<xsl:message>==================================================</xsl:message>   -->
			<xsl:if test="string-length(substring-after($reststring,'.'))>0">.<!-- Ruf dich selbst auf mit Parametern -->
				<xsl:call-template name="linktree2">
					<xsl:with-param name="wurzel" select="$wurzel_a"/>
					<xsl:with-param name="aktuell" select="$aktuell"/>
					<xsl:with-param name="reststring" select="$reststring"/>
				</xsl:call-template>
			</xsl:if>
			<xsl:if test="string-length(substring-after($reststring,'.'))=0">.<!-- this is the last element in the linkchain -->
				<!-- wenn das Element mit der id "$reststring ist ein table, dann class -->
				<!-- wenn id des Knotens mit der id "$reststring ist ein table, dann class 
				<xsl:if test="//*::@id=$reststring">
				<xsl:message><xsl:value-of select="name(//*[@id=concat($wurzel,'.',$reststring)])"/></xsl:message>
				<xsl:if test="name(//*[@id=concat($wurzel,'.',$reststring)])='table'">-->
				<xsl:element name="a">
					<xsl:attribute name="href">#<xsl:value-of select="$databaseID"/>-<xsl:value-of select="concat($wurzel_a,'.',$reststring)"/></xsl:attribute>
					<xsl:attribute name="title"><xsl:value-of select="$databaseID"/>-<xsl:value-of select="concat($wurzel_a,'.',$reststring)"/></xsl:attribute>
					<xsl:value-of select="$reststring"/>
				</xsl:element>
			</xsl:if>
		</xsl:if>
	</xsl:template>
	<!--
Function:     findtable
Parameter:    char table    e.g. "root.com.eosrisq.omdsdownload.data.log.OMDSDownloadLog"
Beschreibung: Holt den Tablename
-->
	<!--dbTableName ostaje nepromenjeno-->
	<xsl:template name="findtable">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<xsl:param name="table"/>
		<xsl:for-each select="//doml:table[@id=$table]">
				<xsl:value-of select="@name"/>
		</xsl:for-each>
	</xsl:template>
	<!--
Function:     findreference
Parameter:    char table    e.g. "root.com.eosrisq.omdsdownload.data.log.OMDSDownloadLog"
Beschreibung: Liefert alle Klassen, die auf table zeigen.
-->
	<!--Tabela relations ispod je uredu-->
	<xsl:template name="findreference">
	<!-- Optimizovano za novu DOML semu - Dejan Betos -->
		<xsl:param name="table"/>
		<br/>
		<table width="100%" bgcolor="#CCFFCC" border="1" cellpadding="0" cellspacing="0" rules="rows" bordercolor="#9CDF9C">
			<tr bordercolor="#CEFFCE">
				<td colspan="3">
					<div align="center" class="big">Relations</div>
				</td>
			</tr>
			<tr bordercolor="#CEFFCE">
				<!--bgcolor="#CCCC33"-->
				<td>
					<b>Class</b>
				</td>
				<td>
					<b>Table Name</b>
				</td>
				<td>
					<b>Attribute</b>
				</td>
			</tr>
			<!--<xsl:param name="table"/>                              -->
			<!--<xsl:for-each select="//doml:databases/doml:database">-->
				<xsl:for-each select="//doml:table">
					<xsl:for-each select="doml:columns/doml:foreignKey">
						<xsl:if test="@foreignTableId=$table">
							<tr>
								<td>
									<xsl:for-each select="../../doml:extendedAttributes/doml:extendedAttribute">
										<xsl:if test="@id='javaName'">
											<xsl:value-of select="@val"/>
										</xsl:if>
									</xsl:for-each>
								</td>
								<td>
									<xsl:variable name="databaseID" select="ancestor::*[name(.)='doml:database']/@id"/>
									<xsl:variable name="parentTableID" select="../../@id"/>
									<xsl:element name="a">
										<xsl:attribute name="href">#<xsl:value-of select="$databaseID"/>-<xsl:value-of select="$parentTableID"/></xsl:attribute>
										<xsl:attribute name="title"><xsl:value-of select="$databaseID"/>-<xsl:value-of select="$parentTableID"/></xsl:attribute>
										<xsl:call-template name="findtable">
											<xsl:with-param name="table">
												<xsl:value-of select="$parentTableID"/>
											</xsl:with-param>
										</xsl:call-template>
									</xsl:element>
								</td>
								<td>
									<xsl:value-of select="@name"/>
								</td>
							</tr>
						</xsl:if>
					</xsl:for-each>
				</xsl:for-each>
		</table>
		<br/>
	</xsl:template>

	<!--ovo ispod je sredjeno i predstavlja prvu tabelu na stranici-->
	<xsl:template name="getclasseswithgenerateSecureInsecure">
		<!--Promenjeno ime templejta iz getclasseswithlazycaching - Slobodan Vujasinovic-->
		<!--Optimizovano za novu DOML semu - Dejan Betos-->
		<table border="0" width="100%" bgcolor="#333333" cellpadding="0" cellspacing="0">
			<tr>
				<td width="38%">
					<h4>
						<font color="#FFFFFF">JavaName</font>
					</h4>
				</td>
				<td width="14%">
					<h4>
						<font color="#FFFFFF">Class</font>
					</h4>
				</td>
				<td width="12%">
					<h4 align="center">
						<font color="#FFFFFF">
							<!--Dodato umesto isLazy  - Slobodan Vujasinovic-->GenSecure</font>
					</h4>
				</td>
				<td width="12%">
					<h4 align="center">
						<font color="#FFFFFF">
							<!--Dodato umesto caching  - Slobodan Vujasinovic-->GenInsecure</font>
					</h4>
				</td>
				<td width="12%">
					<h4 align="center">
						<font color="#FFFFFF">
							<!--Dodato      -dp                              -->MassDeletes</font>
					</h4>
				</td>
				<td width="12%">
					<h4 align="center">
						<font color="#FFFFFF">
							<!--Dodato      -dp                              -->MassUpdates</font>
					</h4>
				</td>				
			</tr>
			<tr>
				<td colspan="7">
					<xsl:for-each select="doml:table">
						<xsl:sort order="ascending" select="@id"/>
							<table border="0" width="100%" bgcolor="#CCFFCC" cellpadding="0" cellspacing="0">
<!--								<xsl:for-each select="table">
									<xsl:sort order="ascending" select="@id"/>-->
									<tr>
										<td width="38%" style="border-bottom:#e1e1e1 solid 1px;">
											<xsl:for-each select="doml:extendedAttributes/doml:extendedAttribute">
												<xsl:if test="@id='javaName'">
													<xsl:value-of select="@val"/>
												</xsl:if>
											</xsl:for-each>
										</td>
										<td width="14%" style="border-bottom:#e1e1e1 solid 1px;">
											<xsl:element name="a">
												<xsl:attribute name="href">#<xsl:value-of select="ancestor::*[name(.)='doml:database']/@id"/>-<xsl:value-of select="@id"/></xsl:attribute>
												<xsl:attribute name="title"><xsl:value-of select="@id"/></xsl:attribute>
												<xsl:value-of select="@id"/>
											</xsl:element>
										</td>
										<td width="12%" style="border-bottom:#e1e1e1 solid 1px;">
											<!--Dodato umesto isLazy  - Slobodan Vujasinovic-->
											<div align="center">
												<xsl:choose>
													<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='generateSecure'">
														<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='generateSecure']/@val"/>
													</xsl:when>
													<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='generateSecure'">
														<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='generateSecure']/@val"/>
													</xsl:when>
													<xsl:otherwise>
														<!--default value-->
														false
													</xsl:otherwise>
												</xsl:choose>
											</div>
										</td>
										<td width="12%" style="border-bottom:#e1e1e1 solid 1px;">
											<!--Dodato umesto caching  - Slobodan Vujasinovic-->
											<div align="center">
												<xsl:choose>
													<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='generateInsecure'">
														<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='generateInsecure']/@val"/>
													</xsl:when>
													<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='generateInsecure'">
														<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='generateInsecure']/@val"/>
													</xsl:when>
													<xsl:otherwise>
														<!--default value-->
														true
													</xsl:otherwise>
												</xsl:choose>
											</div>
										</td>
										<td width="12%" style="border-bottom:#e1e1e1 solid 1px;">
											<div align="center">
												<xsl:choose>
													<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='massDeletes'">
														<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='massDeletes']/@val"/>
													</xsl:when>
													<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='massDeletes'">
														<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='massDeletes']/@val"/>
													</xsl:when>
													<xsl:otherwise>
														<!--default value-->
														false
													</xsl:otherwise>
												</xsl:choose>
											</div>
										</td>
										<td width="12%" style="border-bottom:#e1e1e1 solid 1px;">
											<div align="center">
												<xsl:choose>
													<xsl:when test="doml:extendedAttributes/doml:extendedAttribute/@id='massUpdates'">
														<xsl:value-of select="doml:extendedAttributes/doml:extendedAttribute[@id='massUpdates']/@val"/>
													</xsl:when>
													<xsl:when test="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute/@id='massUpdates'">
														<xsl:value-of select="ancestor::*[name(.)='doml:database']/doml:extendedAttributes/doml:extendedAttribute[@id='massUpdates']/@val"/>
													</xsl:when>
													<xsl:otherwise>
														<!--default value-->
														false
													</xsl:otherwise>
												</xsl:choose>
											</div>
										</td>
									</tr>
<!--								</xsl:for-each>-->
							</table>
<!--						</xsl:if>-->
					</xsl:for-each>
				</td>
			</tr>
		</table>
		<br/>
	</xsl:template>

	<xsl:template name="javadoc">
	<!--Optimizovano za novu DOML semu - Dejan Betos-->
		<table width="100%" bgcolor="#CCFFCC" border="1" cellpadding="0" cellspacing="0" rules="rows" bordercolor="#9CDF9C">
			<!-- Farbteil AttrbiuteTable  -->
			<tr bordercolor="#CEFFCE">
				<td colspan="2">
					<div align="center" class="big">JavaDoc</div>
				</td>
			</tr>
			<tr bordercolor="#CEFFCE">
				<td>
					<b>id</b>
				</td>
				<td>
					<b>Text</b>
				</td>
			</tr>
			
			
			<xsl:for-each select="doml:columns/doml:column[child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='javadoc']]">
					<xsl:call-template name="javadocvalue">
							<xsl:with-param name="column">
									<xsl:value-of select="@id"/>
							</xsl:with-param>
					</xsl:call-template>
			</xsl:for-each>
						
			<xsl:for-each select="doml:columns/doml:foreignKey/doml:fkcolumn[child::*[name(.)='doml:extendedAttributes']/child::*[name(.)='doml:extendedAttribute'][@id='javadoc']]">
					<xsl:call-template name="javadocvalue">
							<xsl:with-param name="column">
										<xsl:value-of select="@name"/>
							</xsl:with-param>
					</xsl:call-template>
			</xsl:for-each>
						
		</table>
	</xsl:template>
	
	<xsl:template name="javadocvalue">
	  <xsl:param name="column"/>
			<tr>
				<td valign="top">
					<xsl:value-of select="$column"/>
				</td>
				<td>
					<pre>
						<xsl:for-each select="doml:extendedAttributes/doml:extendedAttribute">
							<xsl:if test="@id='javadoc'">
								<xsl:value-of select="doml:val"/>
							</xsl:if>
						</xsl:for-each>
					</pre>
				</td>
			</tr>
	</xsl:template>

</xsl:stylesheet>
