package discRack.presentation.delements;

import discRack.presentation.dpanels.DPanel;

import java.util.*;

/**
 * Represents the collection element - thus means that it has simple element
 * with ID attribute.
 *
 * @author Sasa Bojanic
 * @version 1.0
 */
public class DCollectionElement extends DComplexElement {

   protected DSimpleElement attrId=new DSimpleElement("Id"); //required
   protected DCollection myCollection;

   // element by itself doesn't fill the structure - it is up
   // to extended classes to do it
   public DCollectionElement (String name,DCollection myCollection) {
      super(name);

      this.myCollection=myCollection;
   }

   public String getID() {
      return attrId.value.toString();
   }

   public DCollection getCollection () {
      return myCollection;
   }

   protected void fillStructure () {
      attrId.setRequired(true);
      attrId.setReadOnly(true);

      complexStructure.add(attrId);
   }

}